Fancy Tooltip customization in EJ2 JavaScript Tooltip control

27 Feb 202524 minutes to read

The arrow of the Tooltip can be customized as needed by altering the CSS in the sample-side. The EJ2 Tooltip control is implemented using CSS3 formatting, allowing the tip arrow to be positioned according to the Tooltip positions like TopCenter, BottomLeft, RightTop, and more.

Here, the tip arrow is customized as Curved Tooltip and Bubble Tooltip.

Curved tip

To customize the curved tip arrow, override the following CSS class for the tip arrow:

    let tooltip: Tooltip = new Tooltip({
    cssClass: 'curvetips e-tooltip-css',
    content: 'Tooltip arrow customized',
});
tooltip.appendTo('#target');
      .e-arrow-tip-outer.e-tip-bottom,
      .e-arrow-tip-outer.e-tip-top {
           border-left: none !important;
           border-right: none !important;
           border-top: none !important;
      }
      .e-arrow-tip.e-tip-top {
           transform: rotate(170deg);
      }

Bubble tip

The two divs(inner div and outer div) have been added to achieve the bubble tip arrow. To customize the bubble tip arrow, override the following CSS class of tip arrow.

    let bubble: Tooltip = new Tooltip({
    cssClass: 'bubbletip e-tooltip-css',
    position: 'TopRight',
    content: 'Tooltip arrow customized as balloon tip'
});
bubble.appendTo('#bubbletip');
    .e-arrow-tip-outer.e-tip-bottom, .e-arrow-tip-outer.e-tip-top
      {
         border-radius: 50px;
         height: 10px;
         width: 10px;
      }

      .e-arrow-tip-inner.e-tip-bottom, .e-arrow-tip-inner.e-tip-top
        {
         border-radius: 50px;
         height: 10px;
         width: 10px;
        }

These tip arrow customizations are achieved through CSS changes at the sample level. The Tooltip position can be changed using the radio button click event.

The arrow tip pointer can also be disabled by using the showTipPointer property in a Tooltip.

var tooltip = new ej.popups.Tooltip({
  cssClass: 'curvetips e-tooltip-css',
  content: 'Tooltip arrow customized',
});
tooltip.appendTo('#target');

var curvebutton = new ej.buttons.Button();
curvebutton.appendTo('#target');

var tipbutton = new ej.buttons.Button();
tipbutton.appendTo('#tooltip');

var bubblebutton = new ej.buttons.Button();
bubblebutton.appendTo('#bubbletip');

var curveRadio = new ej.buttons.RadioButton({ label: 'TopCenter', name: 'default', value: 'TopCenter', checked: true, change: onChange });

// Render initialized RadioButton.
curveRadio.appendTo('#element1');

var curveRadioLeft = new ej.buttons.RadioButton({ label: 'BottomLeft', name: 'default', value: 'BottomLeft', change: onChange });
curveRadioLeft.appendTo('#element2');

var tippointer = new ej.popups.Tooltip({
  cssClass: 'pointertip e-tooltip-css',
  mouseTrail: true,
  content: 'Disabled tooltip pointer',
  showTipPointer: false
});
tippointer.appendTo('#tooltip');

var bubble = new ej.popups.Tooltip({
  cssClass: 'bubbletip e-tooltip-css',
  position: 'TopRight',
  content: 'Tooltip arrow customized as balloon tip'
});
bubble.appendTo('#bubbletip');

var bubbleRadio = new ej.buttons.RadioButton({ label: 'BottomLeft', name: 'position', value: 'BottomLeft', change: onChanged });

// Render initialized RadioButton.
bubbleRadio.appendTo('#radio1');

var radiobutton = new ej.buttons.RadioButton({ label: 'TopRight', name: 'position', value: 'TopRight', checked: true, change: onChanged });
radiobutton.appendTo('#radio2');

function onChange(args) {
  tooltip.position = args.value;
  tooltip.dataBind();
}
function onChanged(args) {
  bubble.position = args.value;
  if (bubble.position == 'BottomLeft') {
    bubble.offsetY = -30;
  } else {
    bubble.offsetY = 0;
  }
  bubble.dataBind();
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Tooltip</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/30.1.37/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/30.1.37/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/30.1.37/ej2-buttons/styles/material.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/30.1.37/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="customization" class="customTipContainer">
            <button id="target">
                Customized Tip Arrow
            </button>
            <div id="positions">
                <ul>
                    <li>
                        <input type="radio" id="element1">
                    </li>
                    <li>
                        <input type="radio" id="element2">
                    </li>
                </ul>
            </div>
        </div>
        <div id="balloon" class="customTipContainer">
            <button id="bubbletip">
                Bubble Tip Arrow
            </button>
            <div id="btn">
                <ul>
                    <li>
                        <input type="radio" id="radio1">
                    </li>
                    <li>
                        <input type="radio" id="radio2">
                    </li>
                </ul>
            </div>
        </div>
        <div id="disabledContainer" class="customTipContainer">
            <button id="tooltip">
                Disabled Tip Arrow
            </button>
        </div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
    <style>
        #bubbletip {
            border-color: #d2a679;
        }

        #target {
            border-color: #e86238;
        }

        li {
            list-style: none;
        }

        .e-radio-wrapper {
            margin-top: 18px;
        }

        #target,
        #bubbletip,
        #tooltip {
            box-sizing: border-box;
            padding: 20px;
            width: 200px;
            text-align: center;
            top: -17px;
            margin-bottom: 40px;
        }

        /* csslint ignore:start */

        @font-face {
            font-family: "tip";
            src: url("https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.tff") format("truetype"), url("https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.woff") format("woff"), url("https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.eot") format("eot"), url("https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.svg?#tip") format("svg");
            font-weight: normal;
            font-style: normal;
        }

        /* csslint ignore:end */

        /* csslint ignore:start */

        #container {
            width: 100%;
        }

        .customTipContainer {
            width: 400px;
            position: relative;
            left: 50%;
            transform: translateX(-50%);
            top: 50px;
        }

        #disabledContainer {
            margin-top: 25px;
        }

        .pointertip.e-tooltip-wrap .e-tip-content,
        .curvetips.e-tooltip-wrap .e-tip-content {
            color: white;
        }

        .pointertip.e-tooltip-wrap.e-popup {
            background-color: #80180d;
            border: 3px solid #ff9999;
        }

        .curvetips .e-arrow-tip.e-tip-top {
            margin-left: -20px;
            top: -16px;
            transform: rotate(177deg);
            left: 50px;
        }

        .curvetips.e-tooltip-wrap {
            padding: 17px;
            border-radius: 5px;
        }

        .curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom:before,
        .curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top:before {
            font-family: "tip" !important;
            speak-as: none;
            font-size: 21px;
            font-style: normal;
            font-weight: normal;
            font-variant: normal;
            text-transform: none;
            line-height: 1;
            -webkit-font-smoothing: antialiased;
            -moz-osx-font-smoothing: grayscale;
            content: "\e700";
            color: #e86238;
        }

        .curvetips.e-tooltip-wrap.e-popup {
            background: #e86238;
            border: none;
        }

        .curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom,
        .curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top {
            border-left: none;
            border-right: none;
            border-top: none;
        }

        .curvetips.e-tooltip-wrap .e-arrow-tip-inner.e-tip-bottom:before,
        .curvetips.e-tooltip-wrap .e-arrow-tip-inner.e-tip-top:before {
            content: none;
        }

        .curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom,
        .curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top {
            top: -1px;
        }

        .curvetips.e-tooltip-wrap .e-arrow-tip.e-tip-bottom,
        .curvetips.e-tooltip-wrap .e-arrow-tip.e-tip-top {
            position: absolute;
            height: 18px;
            width: 28px;
        }

        #positions {
            display: inline-block;
        }

        #btn {
            display: inline-block;
        }

        #target .e-tip-content {
            padding: 0px;
        }

        .bubbletip.e-tooltip-wrap {
            padding: 8px;
        }

        .bubbletip.e-tooltip-wrap .e-tip-content {
            border-radius: 50%;
            text-align: center;
            color: white;
        }

        .bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-bottom {
            height: 40px;
            width: 50px;
        }

        .bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-top {
            height: 40px;
            width: 40px;
        }

        .bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-left {
            height: 12px;
            width: 20px;
        }

        .bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-right {
            height: 12px;
            width: 20px;
        }

        .bubbletip.e-tooltip-wrap.e-popup {
            border: 5px solid #dfccad;
            background-color: #7b5e32;
        }

        .bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom {
            height: 10px;
            width: 10px;
            border: 1px solid #dfccad;
            background-color: #7b5e32;
            border-radius: 50px;
            margin-top: 20px;
            margin-right: 20px;
        }

        .e-arrow-tip.e-tip-top {
            margin-left: 60px;
        }

        .bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top {
            border: 1px solid #dfccad;
            border-radius: 50px;
            background-color: #7b5e32;
            width: 10px;
            height: 10px;
            margin-left: 20px;
        }

        .bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-left {
            border-bottom: 6px solid transparent;
            border-right: 20px solid #dfccad;
            border-top: 6px solid transparent;
        }

        .bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-right {
            border-bottom: 6px solid transparent;
            border-left: 20px solid #dfccad;
            border-top: 6px solid transparent;
        }

        .bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-bottom {
            margin-top: -2px;
            margin-left: 8px;
            content: none;
            top: 1px !important;
            border: 2px solid #dfccad;
            width: 20px;
            height: 20px;
            border-radius: 50px;
            background-color: #7b5e32;
        }

        .bubbletip .e-arrow-tip.e-tip-top {
            left: 44px !important;
            top: -19px !important;
        }

        .bubbletip .e-arrow-tip.e-tip-bottom {
            top: 88.9% !important;
            left: 4px !important;
        }

        .bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-top {
            top: 10px !important;
            border: 2px solid #dfccad;
            width: 20px;
            height: 20px;
            border-radius: 50px;
            background-color: #7b5e32;
        }

        .bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-top:before {
            content: None;
        }

        .bubbletip.e-tooltip-wrap .e-tip-content {
            border-radius: inherit;
        }

        .bubbletip.e-tooltip-wrap.bubbletip {
            width: 150px !important;
            border-radius: 50%;
        }

        /* csslint ignore:end */
    </style>
</body>

</html>
#container {
  visibility: hidden;
}

#loader {
  color: #008cff;
  height: 40px;
  left: 45%;
  position: absolute;
  top: 45%;
  width: 30%;
}

Fancy customization of Angular Tooltip component

6 Mar 202517 minutes to read

The arrow of the Tooltip can be customized as needed by customizing CSS in the sample level.

The EJ2 Tooltip component is styled using CSS3 and positions the tip arrow according to the Tooltip positions such as TopCenter, BottomLeft, RightTop, and others.

Here, the tip arrow is customized as Curved Tooltip and Bubble Tooltip.

Curved tip

The content for the tip pointer arrow has been added. To customize the curved tip arrow, override the following CSS class of tip arrow.

.e-arrow-tip-outer.e-tip-bottom,
.e-arrow-tip-outer.e-tip-top {
     border-left: none !important;
     border-right: none !important;
     border-top: none !important;
}

.e-arrow-tip.e-tip-top {
     transform: rotate(170deg);
}

Bubble tip

The two divs(inner div and outer div) have been added to achieve the bubble tip arrow. To customize the bubble tip arrow, override the following CSS class of tip arrow.

.e-arrow-tip-outer.e-tip-bottom, .e-arrow-tip-outer.e-tip-top
{
   border-radius: 50px;
   height: 10px;
   width: 10px;
}

.e-arrow-tip-inner.e-tip-bottom, .e-arrow-tip-inner.e-tip-top
  {
   border-radius: 50px;
   height: 10px;
   width: 10px;
  }

These tip arrow customizations have been achieved through CSS changes in the sample level. The Tooltip position can be changed by using the radio button click event.

The arrow tip pointer can also be disabled using the showTipPointer property.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TooltipModule } from '@syncfusion/ej2-angular-popups'
import { RadioButtonModule } from '@syncfusion/ej2-angular-buttons'




import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { TooltipComponent } from '@syncfusion/ej2-angular-popups';
import { ChangeArgs } from '@syncfusion/ej2-buttons';

@Component({
    imports: [

        TooltipModule, RadioButtonModule
    ],


    standalone: true,
    selector: 'my-app',
    template: `
     <div id="customization">
      <ejs-tooltip #tooltipcurve cssClass='curvetips e-tooltip-css' content='Tooltip arrow customized'>
            <button id="target">
                Curve Tip Arrow
            </button>
        </ejs-tooltip>
       </div>
        <div id="positions">
            <ul>
             <li><ejs-radiobutton label="TopCenter" value="TopCenter" name="state" checked='true' (change)="onChange($event)"></ejs-radiobutton></li>
              <li><ejs-radiobutton label="BottomLeft" value="BottomLeft" name="state" (change)="onChange($event)"></ejs-radiobutton></li>
            </ul>
        </div>
     <div id="balloon">
      <ejs-tooltip #tooltipCustom cssClass='bubbletip e-tooltip-css' content='Tooltip arrow customized as balloon tip' position='TopRight'>
            <button id="bubbletip">
                Bubble Tip Arrow
            </button>
        </ejs-tooltip>
       </div>
        <div id="btn">
            <ul>
             <li><ejs-radiobutton label="TopRight" value="TopRight" name="default" [checked]="true" (change)="onChanged($event)"></ejs-radiobutton></li>
              <li><ejs-radiobutton label="BottomLeft" value="BottomLeft" name="default" (change)="onChanged($event)"></ejs-radiobutton></li>
            </ul>
        </div>
        <ejs-tooltip #tooltip cssClass='pointertip e-tooltip-css' content='Disabled Tooltip Pointer' mouseTrail='true' [showTipPointer]='false'>
        <button id="tooltip">
            Disabled Tip Arrow
        </button>
        </ejs-tooltip>
    `,
    encapsulation: ViewEncapsulation.None,
})

export class AppComponent {
    @ViewChild('tooltip')
    public tooltipControl: TooltipComponent | any;
    @ViewChild('tooltipcurve')
    public tooltipCurve: TooltipComponent | any;
    @ViewChild('tooltipCustom')
    public tooltipCustom: TooltipComponent | any;
    constructor() { }
    onChange(args: ChangeArgs): void {
        this.tooltipCurve.position = args.value as any;
        this.tooltipCurve.dataBind();
    }
    onChanged(args: ChangeArgs): void {
        this.tooltipCustom.position = args.value as any;
        if (this.tooltipCustom.position == 'BottomLeft') {
            this.tooltipCustom.offsetY = -30;
        } else {
            this.tooltipCustom.offsetY = 0;
        }
        this.tooltipCustom.dataBind();
    }
}
@import 'node_modules/@syncfusion/ej2-base/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-popups/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-base/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-buttons/styles/material.css';

/* csslint ignore:start */
#loader {
    color: #008cff;
    font-family: 'Helvetica Neue', 'calibiri', sans-serif;
    font-size: 16px;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
  }
  
  #bubbletip {
    border-color: #d2a679;
  }

  #tooltip {
    border-color: #80180d;
    margin: 100px 0 0 100px;
  }

  #target {
    border-color: #e86238;
  }

  li {
    list-style: none;
  }

  .e-radio-wrapper {
    margin-top: 18px;
  }
  
  #target, #bubbletip, #tooltip {
    box-sizing: border-box;
    padding: 20px;
    width: 200px;
    text-align: center;
    top: -17px;
    margin-bottom: 40px;
  }
  
  @font-face {
    font-family: "tip";
    src: url("//ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.tff") format("truetype"),
         url("//ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.woff") format("woff"),
         url("//ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.eot") format("eot"),
         url("//ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.svg#tip") format("svg");
    font-weight: normal;
    font-style: normal;
  }
  
  #container {
    width: 100%;
  }
  
  #customization {
    padding-top: 40px;
    display: inline-block;
    margin: 40px 0 0 100px;
  }
  
  #balloon {
    display: inline-block;
    margin: 100px 0 0 100px;
  }
  
  .pointertip.e-tooltip-wrap .e-tip-content,
  .curvetips.e-tooltip-wrap .e-tip-content {
    color: white;
  }
  
  .pointertip.e-tooltip-wrap.e-popup {
    background-color: #80180d;
    border: 3px solid #ff9999;
  }
  
  .curvetips .e-arrow-tip.e-tip-top {
    margin-left: -20px;
    top: -16px;
    transform: rotate(177deg);
    left: 50px;
  }
  
  .curvetips.e-tooltip-wrap {
    padding: 17px;
    border-radius: 5px;
    background: #e86238;
    border: none;
  }
  
  .curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom:before,
  .curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top:before {
    font-family: "tip" !important;
    speak: none;
    font-size: 21px;
    font-style: normal;
    font-weight: normal;
    font-variant: normal;
    text-transform: none;
    line-height: 1;
    -webkit-font-smoothing: antialiased;
    -moz-osx-font-smoothing: grayscale;
    content: "\e700";
    color: #e86238;
  }
  
  .curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom,
  .curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top {
    border: none;
    top: -1px;
  }
  
  .curvetips.e-tooltip-wrap .e-arrow-tip.e-tip-bottom,
  .curvetips.e-tooltip-wrap .e-arrow-tip.e-tip-top {
    position: absolute;
    height: 18px;
    width: 28px;
  }
  
  #positions,
  #btn {
    display: inline-block;
  }

  #target .e-tip-content {
    padding: 0;
  }
  
  .bubbletip.e-tooltip-wrap {
    padding: 8px;
    border: 5px solid #dfccad;
    background-color: #7b5e32;
    width: 150px !important;
    border-radius: 50%;
  }
  
  .bubbletip.e-tooltip-wrap .e-tip-content {
    border-radius: 50%;
    text-align: center;
    color: white;
  }
  
  .bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-bottom { height: 40px; width: 50px; }
  .bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-top { height: 40px; width: 40px; }
  .bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-left,
  .bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-right { height: 12px; width: 20px; }
  
  .bubbletip.e-tooltip-wrap .e-arrow-tip-outer {
    border: 1px solid #dfccad;
    background-color: #7b5e32;
  }
  
  .bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom,
  .bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top {
    width: 10px;
    height: 10px;
    border-radius: 50px;
  }
  
  .bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom {
    margin: 20px 20px 0 0;
  }

  .bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top {
    margin-left: 20px;
  }
  .bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-left,
  .bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-right {
    border-top: 6px solid transparent;
    border-bottom: 6px solid transparent;
  }
  
  .bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-left {
    border-right: 20px solid #dfccad;
  }

  .bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-right {
    border-left: 20px solid #dfccad;
  }
  .bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-bottom,
  .bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-top {
    border: 2px solid #dfccad;
    width: 20px;
    height: 20px;
    border-radius: 50px;
    background-color: #7b5e32;
  }
  
  .bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-bottom {
    margin: -2px 0 0 8px;
    top: 1px !important;
  }
  
  .bubbletip .e-arrow-tip.e-tip-top {
    left: 44px !important;
    top: -19px !important;
  }

  .bubbletip .e-arrow-tip.e-tip-bottom {
    top: 88.9% !important;
    left: 4px !important;
  }

  .bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-top {
    top: 10px !important;
  }

  .bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-top:before {
    content: none;
  }
  
  /* csslint ignore:end */
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Fancy tooltip customization in Vue Tooltip component

21 Feb 202524 minutes to read

The arrow of the tooltip can be customized as needed by modifying CSS on the sample side. The EJ2 tooltip component is achieved through CSS3 format and positions the tip arrow according to the tooltip positions like TopCenter, BottomLeft, RightTop, and more.

Here, the tip arrow is customized as Curved tooltip and Bubble Tooltip.

Curved tip

Content has been added for the tip pointer arrow. To customize the curved tip arrow, override the following CSS class of the tip arrow.

      .e-arrow-tip-outer.e-tip-bottom,
      .e-arrow-tip-outer.e-tip-top {
           border-left: none !important;
           border-right: none !important;
           border-top: none !important;
      }
      .e-arrow-tip.e-tip-top {
           transform: rotate(170deg);
      }

Bubble tip

Two divs(inner div and outer div) elements have been added to achieve the bubble tip arrow. To customize the bubble tip arrow, override the following CSS class of the tip arrow.

    .e-arrow-tip-outer.e-tip-bottom, .e-arrow-tip-outer.e-tip-top
      {
         border-radius: 50px;
         height: 10px;
         width: 10px;
      }

      .e-arrow-tip-inner.e-tip-bottom, .e-arrow-tip-inner.e-tip-top
        {
         border-radius: 50px;
         height: 10px;
         width: 10px;
        }

These tip arrow customizations have been achieved through CSS changes at the sample level. The tooltip position can be changed by using the radio button click event.

The arrow tip pointer can also be disabled by using the showTipPointer property in a Tooltip.

<template>
  <div id='app'>
    <ejs-tooltip ref='tooltip_1' cssClass="curvetips e-tooltip-css" content="Tooltip arrow customized" target="#target">
      <ejs-tooltip mouseTrail=true :showTipPointer=false content='Disabled tooltip pointer' target='#tooltip'
        cssClass='pointertip e-tooltip-css'>
        <ejs-tooltip position="TopRight" content='Tooltip arrow customized as balloon tip' target='#bubbletip'
          cssClass='bubbletip e-tooltip-css' ref="tooltip_2">
          <div id='container'>
            <div id="customization" class="customTipContainer">
              <ejs-button id="target">
                Customized Tip Arrow
              </ejs-button>
              <div id="positions">
                <ul>
                  <li>
                    <ejs-radiobutton id='element1' label='TopCenter' name='default' value='TopCenter' checked=true
                      v-on:change='onChange' />
                  </li>
                  <li>
                    <ejs-radiobutton id='element2' label='BottomLeft' name='default' value='BottomLeft'
                      v-on:change='onChange' />
                  </li>
                </ul>
              </div>
            </div>
            <div id="balloon" class="customTipContainer">
              <ejs-button id="bubbletip">
                Bubble Tip Arrow
              </ejs-button>
              <div id="btn">
                <ul>
                  <li>
                    <ejs-radiobutton id='radio1' label='BottomLeft' name='position' value='BottomLeft'
                      v-on:change='onChanged' />
                  </li>
                  <li>
                    <ejs-radiobutton id='radio2' label='TopRight' name='position' value='TopRight' checked=true
                      v-on:change='onChanged' />
                  </li>
                </ul>
              </div>
            </div>
            <div id="disabledContainer" class="customTipContainer">
              <ejs-button id="tooltip">
                Disabled Tip Arrow
              </ejs-button>
            </div>
          </div>
        </ejs-tooltip>
      </ejs-tooltip>
    </ejs-tooltip>
  </div>
</template>
<script setup>
import { ButtonComponent as EjsButton } from '@syncfusion/ej2-vue-buttons';
import { TooltipComponent as EjsTooltip } from '@syncfusion/ej2-vue-popups';
import { RadioButtonComponent as ejsRadiobutton } from "@syncfusion/ej2-vue-buttons";
import { ref } from 'vue';

const tooltip_1 = ref(null);
const tooltip_2 = ref(null);

const onChange = (args) => {
  tooltip_1.value.ej2Instances.position = args.value;
  tooltip_1.value.dataBind();
};
const onChanged = (args) => {
  tooltip_2.value.ej2Instances.position = args.value;
  if (tooltip_2.value.ej2Instances.position == 'BottomLeft') {
    tooltip_2.value.ej2Instances.offsetY = -30;
  } else {
    tooltip_2.value.ej2Instances.offsetY = 0;
  }
  tooltip_2.value.dataBind();
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";

#bubbletip {
  border-color: #d2a679;
}

#target {
  border-color: #e86238;
}

li {
  list-style: none;
}

.e-radio-wrapper {
  margin-top: 18px;
}

#target,
#bubbletip,
#tooltip {
  box-sizing: border-box;
  padding: 20px;
  width: 200px;
  text-align: center;
  top: -17px;
  margin-bottom: 40px;
}

@font-face {
  font-family: 'tip';
  src: url('https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.tff')
      format('truetype'),
    url('https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.woff')
      format('woff'),
    url('https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.eot')
      format('eot'),
    url('https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.svg?#tip')
      format('svg');
  font-weight: normal;
  font-style: normal;
}

#container {
  width: 100%;
}

.customTipContainer {
  width: 400px;
  position: relative;
  left: 50%;
  transform: translateX(-50%);
  top: 50px;
}

#disabledContainer {
  margin-top: 25px;
}

.pointertip.e-tooltip-wrap .e-tip-content,
.curvetips.e-tooltip-wrap .e-tip-content {
  color: white;
}

.pointertip.e-tooltip-wrap.e-popup {
  background-color: #80180d;
  border: 3px solid #ff9999;
}

.curvetips .e-arrow-tip.e-tip-top {
  margin-left: -20px;
  top: -16px;
  transform: rotate(177deg);
  left: 50px;
}

.curvetips.e-tooltip-wrap {
  padding: 17px;
  border-radius: 5px;
}

.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom:before,
.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top:before {
  font-family: 'tip' !important;
  speak-as: none;
  font-size: 21px;
  font-style: normal;
  font-weight: normal;
  font-variant: normal;
  text-transform: none;
  line-height: 1;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  content: '\\e700';
  color: #e86238;
}

.curvetips.e-tooltip-wrap.e-popup {
  background: #e86238;
  border: none;
}

.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom,
.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top {
  border-left: none;
  border-right: none;
  border-top: none;
}

.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom,
.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top {
  top: -1px;
}

.curvetips.e-tooltip-wrap .e-arrow-tip.e-tip-bottom,
.curvetips.e-tooltip-wrap .e-arrow-tip.e-tip-top {
  position: absolute;
  height: 18px;
  width: 28px;
}

#positions, #btn {
  display: inline-block;
}

#target .e-tip-content {
  padding: 0px;
}

.bubbletip.e-tooltip-wrap {
  padding: 8px;
}

.bubbletip.e-tooltip-wrap .e-tip-content {
  border-radius: 50%;
  text-align: center;
  color: white;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-bottom {
  height: 40px;
  width: 50px;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-top {
  height: 40px;
  width: 40px;
}

.bubbletip.e-tooltip-wrap.e-popup {
  border: 5px solid #dfccad;
  background-color: #7b5e32;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom {
  height: 10px;
  width: 10px;
  border: 1px solid #dfccad;
  background-color: #7b5e32;
  border-radius: 50px;
  margin-top: 20px;
  margin-right: 20px;
}

.e-arrow-tip.e-tip-top {
  margin-left: 60px;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top {
  border: 1px solid #dfccad;
  border-radius: 50px;
  background-color: #7b5e32;
  width: 10px;
  height: 10px;
  margin-left: 20px;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-bottom {
  margin-top: -2px;
  margin-left: 8px;
  content: none;
  top: 1px !important;
  border: 2px solid #dfccad;
  width: 20px;
  height: 20px;
  border-radius: 50px;
  background-color: #7b5e32;
}

.bubbletip .e-arrow-tip.e-tip-top {
  left: 44px !important;
  top: -19px !important;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-top {
  top: 10px !important;
  border: 2px solid #dfccad;
  width: 20px;
  height: 20px;
  border-radius: 50px;
  background-color: #7b5e32;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-top:before {
  content: none;
}

.bubbletip.e-tooltip-wrap.bubbletip {
  width: 150px !important;
  border-radius: 50%;
}
</style>
<template>
  <div id='app'>
       <ejs-tooltip ref='tooltip_1' cssClass="curvetips e-tooltip-css" content="Tooltip arrow customized" target="#target">
           <ejs-tooltip mouseTrail=true :showTipPointer=false content='Disabled tooltip pointer' target='#tooltip' cssClass='pointertip e-tooltip-css'>
               <ejs-tooltip position="TopRight" content='Tooltip arrow customized as balloon tip' target='#bubbletip' cssClass='bubbletip e-tooltip-css' ref="tooltip_2">
                   <div id='container'>
                       <div id="customization" class="customTipContainer">
                           <ejs-button id="target">
                               Customized Tip Arrow
                           </ejs-button>
                           <div id="positions">
                               <ul>
                                   <li>
                                       <ejs-radiobutton id='element1' label='TopCenter' name='default' value='TopCenter' checked=true  v-on:change='onChange'/>
                                   </li>
                                   <li>
                                       <ejs-radiobutton id='element2' label='BottomLeft' name='default' value='BottomLeft' v-on:change='onChange'/>
                                   </li>
                               </ul>
                           </div>
                       </div>
                       <div id="balloon" class="customTipContainer">
                           <ejs-button id="bubbletip">
                               Bubble Tip Arrow
                           </ejs-button>
                           <div id="btn">
                               <ul>
                                   <li>
                                       <ejs-radiobutton id='radio1' label='BottomLeft' name='position' value='BottomLeft' v-on:change='onChanged'/>
                                   </li>
                                   <li>
                                       <ejs-radiobutton id='radio2' label='TopRight' name='position' value='TopRight'  checked=true v-on:change='onChanged'/>
                                   </li>
                               </ul>
                           </div>
                       </div>
                       <div id="disabledContainer" class="customTipContainer">
                           <ejs-button id="tooltip">
                               Disabled Tip Arrow
                           </ejs-button>
                       </div>
                   </div>
               </ejs-tooltip>
           </ejs-tooltip>
       </ejs-tooltip>
   </div>
</template>
<script>

import { ButtonComponent } from '@syncfusion/ej2-vue-buttons';
import { TooltipComponent } from '@syncfusion/ej2-vue-popups';
import { RadioButtonComponent } from "@syncfusion/ej2-vue-buttons";

export default {
name: "App",
components: {
"ejs-tooltip":TooltipComponent,
"ejs-button":ButtonComponent,
"ejs-radiobutton":RadioButtonComponent
},
 data: function() {
   return {
   };
 },
 methods: {
       onChange(args) {
           this.$refs.tooltip_1.ej2Instances.position = args.value;
           this.$refs.tooltip_1.dataBind();
       },
       onChanged(args) {
           this.$refs.tooltip_2.ej2Instances.position = args.value;
           if(this.$refs.tooltip_2.ej2Instances.position == 'BottomLeft'){
            this.$refs.tooltip_2.ej2Instances.offsetY = -30;
           } else {
            this.$refs.tooltip_2.ej2Instances.offsetY = 0;
           }
            this.$refs.tooltip_2.dataBind();
       }

 }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
#bubbletip {
  border-color: #d2a679;
}

#target {
  border-color: #e86238;
}

li {
  list-style: none;
}

.e-radio-wrapper {
  margin-top: 18px;
}

#target,
#bubbletip,
#tooltip {
  box-sizing: border-box;
  padding: 20px;
  width: 200px;
  text-align: center;
  top: -17px;
  margin-bottom: 40px;
}

@font-face {
  font-family: 'tip';
  src: url('https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.tff')
      format('truetype'),
    url('https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.woff')
      format('woff'),
    url('https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.eot')
      format('eot'),
    url('https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.svg?#tip')
      format('svg');
  font-weight: normal;
  font-style: normal;
}

#container {
  width: 100%;
}

.customTipContainer {
  width: 400px;
  position: relative;
  left: 50%;
  transform: translateX(-50%);
  top: 50px;
}

#disabledContainer {
  margin-top: 25px;
}

.pointertip.e-tooltip-wrap .e-tip-content,
.curvetips.e-tooltip-wrap .e-tip-content {
  color: white;
}

.pointertip.e-tooltip-wrap.e-popup {
  background-color: #80180d;
  border: 3px solid #ff9999;
}

.curvetips .e-arrow-tip.e-tip-top {
  margin-left: -20px;
  top: -16px;
  transform: rotate(177deg);
  left: 50px;
}

.curvetips.e-tooltip-wrap {
  padding: 17px;
  border-radius: 5px;
}

.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom:before,
.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top:before {
  font-family: 'tip' !important;
  speak-as: none;
  font-size: 21px;
  font-style: normal;
  font-weight: normal;
  font-variant: normal;
  text-transform: none;
  line-height: 1;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  content: '\\e700';
  color: #e86238;
}

.curvetips.e-tooltip-wrap.e-popup {
  background: #e86238;
  border: none;
}

.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom,
.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top {
  border-left: none;
  border-right: none;
  border-top: none;
}

.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom,
.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top {
  top: -1px;
}

.curvetips.e-tooltip-wrap .e-arrow-tip.e-tip-bottom,
.curvetips.e-tooltip-wrap .e-arrow-tip.e-tip-top {
  position: absolute;
  height: 18px;
  width: 28px;
}

#positions, #btn {
  display: inline-block;
}

#target .e-tip-content {
  padding: 0px;
}

.bubbletip.e-tooltip-wrap {
  padding: 8px;
}

.bubbletip.e-tooltip-wrap .e-tip-content {
  border-radius: 50%;
  text-align: center;
  color: white;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-bottom {
  height: 40px;
  width: 50px;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-top {
  height: 40px;
  width: 40px;
}

.bubbletip.e-tooltip-wrap.e-popup {
  border: 5px solid #dfccad;
  background-color: #7b5e32;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom {
  height: 10px;
  width: 10px;
  border: 1px solid #dfccad;
  background-color: #7b5e32;
  border-radius: 50px;
  margin-top: 20px;
  margin-right: 20px;
}

.e-arrow-tip.e-tip-top {
  margin-left: 60px;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top {
  border: 1px solid #dfccad;
  border-radius: 50px;
  background-color: #7b5e32;
  width: 10px;
  height: 10px;
  margin-left: 20px;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-bottom {
  margin-top: -2px;
  margin-left: 8px;
  content: none;
  top: 1px !important;
  border: 2px solid #dfccad;
  width: 20px;
  height: 20px;
  border-radius: 50px;
  background-color: #7b5e32;
}

.bubbletip .e-arrow-tip.e-tip-top {
  left: 44px !important;
  top: -19px !important;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-top {
  top: 10px !important;
  border: 2px solid #dfccad;
  width: 20px;
  height: 20px;
  border-radius: 50px;
  background-color: #7b5e32;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-top:before {
  content: none;
}

.bubbletip.e-tooltip-wrap.bubbletip {
  width: 150px !important;
  border-radius: 50%;
}
</style>

Fancy Tooltip customization in React Tooltip component

28 Feb 202524 minutes to read

The arrow of the Tooltip can be customized as needed by customizing CSS on the sample side.

The React Tooltip component is styled using CSS3 and positions the tip arrow according to the Tooltip positions such as TopCenter, BottomLeft, RightTop, and more.

Here, the tip arrow is customized as Curved Tooltip and Bubble tooltip.

Curved tip

The content for the tip pointer arrow has been added. To customize the curved tip arrow, override the following CSS classes of the tip arrow.

 <TooltipComponent content='Tooltip Content' cssClass='curvetips e-tooltip-css'>
    </TooltipComponent>
  .e-arrow-tip-outer.e-tip-bottom,
  .e-arrow-tip-outer.e-tip-top {
        border-left: none !important;
        border-right: none !important;
        border-top: none !important;
  }
  .e-arrow-tip.e-tip-top {
        transform: rotate(170deg);
  }

Bubble tip

The two divs (inner div and outer div) have been added to achieve the bubble tip arrow. To customize the bubble tip arrow, override the following CSS classes of the tip arrow.

  <TooltipComponent content='Tooltip Content' cssClass='bubbletip e-tooltip-css'>
  </TooltipComponent>
    .e-arrow-tip-outer.e-tip-bottom, .e-arrow-tip-outer.e-tip-top
    {
      border-radius: 50px;
      height: 10px;
      width: 10px;
    }

    .e-arrow-tip-inner.e-tip-bottom, .e-arrow-tip-inner.e-tip-top
    {
      border-radius: 50px;
      height: 10px;
      width: 10px;
    }

These tip arrow customizations are achieved through CSS changes at the sample level. The Tooltip position can be changed using the radio button click event.

The arrow tip pointer can also be disabled using the showTipPointer property of the tooltip.

import * as React from 'react';
import { TooltipComponent } from '@syncfusion/ej2-react-popups';
import { ButtonComponent, RadioButtonComponent, } from '@syncfusion/ej2-react-buttons';
function App() {
  let tooltip;
  let bubble;
  function onChange(args) {
    tooltip.position = args.value;
    tooltip.dataBind();
  }
  function onChanged(args) {
    bubble.position = args.value;
    if (bubble.position == "BottomLeft") {
      bubble.offsetY = -30;
    }
    else {
      bubble.offsetY = 0;
    }
    bubble.dataBind();
  }
  return (<div id="container">
    <TooltipComponent cssClass="curvetips e-tooltip-css" content="Tooltip arrow customized" target="#target" ref={d => (tooltip = d)}>
      <TooltipComponent cssClass="bubbletip e-tooltip-css" content="Tooltip arrow customized as balloon tip" target="#bubbletip" position="TopRight" ref={d => (bubble = d)}>
        <TooltipComponent cssClass="pointertip e-tooltip-css" mouseTrail={true} target="#tooltip" content="Disabled Tooltip pointer" showTipPointer={false}>
          <div id="customization" className="customTipContainer">
            <ButtonComponent id="target">Customized Tip Arrow</ButtonComponent>
            <div id="positions">
              <ul>
                <li>
                  <RadioButtonComponent id="element1" label="TopCenter" name="default" checked={true} value="TopCenter" change={onChange} />
                </li>
                <li>
                  <RadioButtonComponent id="element2" label="BottomLeft" name="default" value="BottomLeft" change={onChange} />
                </li>
              </ul>
            </div>
          </div>
          <div id="balloon" className="customTipContainer">
            <ButtonComponent id="bubbletip">Bubble Tip Arrow</ButtonComponent>
            <div id="btn">
              <ul>
                <li>
                  <RadioButtonComponent id="radio1" label="BottomLeft" name="position" value="BottomLeft" change={onChanged} />
                </li>
                <li>
                  <RadioButtonComponent id="radio2" label="TopRight" name="position" value="TopRight" checked={true} change={onChanged} />
                </li>
              </ul>
            </div>
          </div>
          <div id="disabledContainer" className="customTipContainer">
            <ButtonComponent id="tooltip">Disabled Tip Arrow</ButtonComponent>
          </div>
        </TooltipComponent>
      </TooltipComponent>
    </TooltipComponent>
  </div>);
}
export default App;
import * as React from 'react';
import { TooltipComponent } from '@syncfusion/ej2-react-popups';
import {
  ButtonComponent,
  RadioButtonComponent,
  ChangeArgs,
} from '@syncfusion/ej2-react-buttons';

function App() {
  let tooltip: TooltipComponent;
  let bubble: TooltipComponent;

  function onChange(args: ChangeArgs): void {
    tooltip.position = args.value as any;
    tooltip.dataBind();
  }

  function onChanged(args: ChangeArgs): void {
    bubble.position = args.value as any;
    if (bubble.position == "BottomLeft") {
      bubble.offsetY = -30;
    } else {
      bubble.offsetY = 0;
    }
    bubble.dataBind();
  }
  return (
    <div id="container">
      <TooltipComponent
        cssClass="curvetips e-tooltip-css"
        content="Tooltip arrow customized"
        target="#target"
        ref={d => (tooltip = d as any)}
      >
        <TooltipComponent
          cssClass="bubbletip e-tooltip-css"
          content="Tooltip arrow customized as balloon tip"
          target="#bubbletip"
          position="TopRight"
          ref={d => (bubble = d as any)}
        >
          <TooltipComponent
            cssClass="pointertip e-tooltip-css"
            mouseTrail={true}
            target="#tooltip"
            content="Disabled Tooltip pointer"
            showTipPointer={false}
          >
            <div id="customization" className="customTipContainer">
              <ButtonComponent id="target">Customized Tip Arrow</ButtonComponent>
              <div id="positions">
                <ul>
                  <li>
                    <RadioButtonComponent
                      id="element1"
                      label="TopCenter"
                      name="default"
                      checked={true}
                      value="TopCenter"
                      change={onChange as any}
                    />
                  </li>
                  <li>
                    <RadioButtonComponent
                      id="element2"
                      label="BottomLeft"
                      name="default"
                      value="BottomLeft"
                      change={onChange as any}
                    />
                  </li>
                </ul>
              </div>
            </div>
            <div id="balloon" className="customTipContainer">
              <ButtonComponent id="bubbletip">Bubble Tip Arrow</ButtonComponent>
              <div id="btn">
                <ul>
                  <li>
                    <RadioButtonComponent
                      id="radio1"
                      label="BottomLeft"
                      name="position"
                      value="BottomLeft"
                      change={onChanged as any}
                    />
                  </li>
                  <li>
                    <RadioButtonComponent
                      id="radio2"
                      label="TopRight"
                      name="position"
                      value="TopRight"
                      checked={true}
                      change={onChanged as any}
                    />
                  </li>
                </ul>
              </div>
            </div>
            <div id="disabledContainer" className="customTipContainer">
              <ButtonComponent id="tooltip">Disabled Tip Arrow</ButtonComponent>
            </div>
          </TooltipComponent>
        </TooltipComponent>
      </TooltipComponent>
    </div>
  );
}
export default App;
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { TooltipComponent } from '@syncfusion/ej2-react-popups';
import { RadioButtonComponent, } from '@syncfusion/ej2-react-buttons';
function App() {
  let tooltip;
  let bubble;
  function onChange(args) {
    tooltip.position = args.value;
    tooltip.dataBind();
  }
  function onChanged(args) {
    bubble.position = args.value;
    if (bubble.position == 'BottomLeft') {
      bubble.offsetY = -30;
    }
    else {
      bubble.offsetY = 0;
    }
    bubble.dataBind();
  }
  return (<div id="container">
    <TooltipComponent cssClass="curvetips e-tooltip-css" content="Tooltip arrow customized" target="#target" ref={d =>tooltip = d}>
      <TooltipComponent cssClass="bubbletip e-tooltip-css" content="Tooltip arrow customized as balloon tip" target="#bubbletip" position="TopRight" ref={d => bubble = d}>
        <TooltipComponent cssClass="pointertip e-tooltip-css" mouseTrail={true} target="#tooltip" content="Disabled Tooltip pointer" showTipPointer={false}>
          <div id="customization" className="customTipContainer">
            <button className="e-btn" id="target">
              Customized Tip Arrow
            </button>
            <div id="positions">
              <ul>
                <li>
                  <RadioButtonComponent id="element1" label="TopCenter" name="default" checked={true} value="TopCenter" change={onChange} />
                </li>
                <li>
                  <RadioButtonComponent id="element2" label="BottomLeft" name="default" value="BottomLeft" change={onChange} />
                </li>
              </ul>
            </div>
          </div>
          <div id="balloon" className="customTipContainer">
            <button className="e-btn" id="bubbletip">
              Bubble Tip Arrow
            </button>
            <div id="btn">
              <ul>
                <li>
                  <RadioButtonComponent id="radio1" label="BottomLeft" name="position" value="BottomLeft" change={onChanged} />
                </li>
                <li>
                  <RadioButtonComponent id="radio2" label="TopRight" name="position" value="TopRight" checked={true} change={onChanged} />
                </li>
              </ul>
            </div>
          </div>
          <div id="disabledContainer" className="customTipContainer">
            <button className="e-btn" id="tooltip">
              Disabled Tip Arrow
            </button>
          </div>
        </TooltipComponent>
      </TooltipComponent>
    </TooltipComponent>
  </div>);
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { TooltipComponent } from '@syncfusion/ej2-react-popups';
import {
  RadioButtonComponent,
  ChangeArgs,
} from '@syncfusion/ej2-react-buttons';

function App() {
  let tooltip: TooltipComponent;
  let bubble: TooltipComponent;

  function onChange(args: ChangeArgs): void {
    tooltip.position = args.value as any;
    tooltip.dataBind();
  }

  function onChanged(args: ChangeArgs): void {
    bubble.position = args.value as any;
    if (bubble.position == 'BottomLeft') {
      bubble.offsetY = -30;
    } else {
      bubble.offsetY = 0;
    }
    bubble.dataBind();
  }
  return (
    <div id="container">
      <TooltipComponent
        cssClass="curvetips e-tooltip-css"
        content="Tooltip arrow customized"
        target="#target"
        ref={d =>tooltip = d}
      >
        <TooltipComponent
          cssClass="bubbletip e-tooltip-css"
          content="Tooltip arrow customized as balloon tip"
          target="#bubbletip"
          position="TopRight"
          ref={d => bubble = d}
        >
          <TooltipComponent
            cssClass="pointertip e-tooltip-css"
            mouseTrail={true}
            target="#tooltip"
            content="Disabled Tooltip pointer"
            showTipPointer={false}
          >
            <div id="customization" className="customTipContainer">
              <button className="e-btn" id="target">
                Customized Tip Arrow
              </button>
              <div id="positions">
                <ul>
                  <li>
                    <RadioButtonComponent
                      id="element1"
                      label="TopCenter"
                      name="default"
                      checked={true}
                      value="TopCenter"
                      change={onChange}
                    />
                  </li>
                  <li>
                    <RadioButtonComponent
                      id="element2"
                      label="BottomLeft"
                      name="default"
                      value="BottomLeft"
                      change={onChange}
                    />
                  </li>
                </ul>
              </div>
            </div>
            <div id="balloon" className="customTipContainer">
              <button className="e-btn" id="bubbletip">
                Bubble Tip Arrow
              </button>
              <div id="btn">
                <ul>
                  <li>
                    <RadioButtonComponent
                      id="radio1"
                      label="BottomLeft"
                      name="position"
                      value="BottomLeft"
                      change={onChanged}
                    />
                  </li>
                  <li>
                    <RadioButtonComponent
                      id="radio2"
                      label="TopRight"
                      name="position"
                      value="TopRight"
                      checked={true}
                      change={onChanged}
                    />
                  </li>
                </ul>
              </div>
            </div>
            <div id="disabledContainer" className="customTipContainer">
              <button className="e-btn" id="tooltip">
                Disabled Tip Arrow
              </button>
            </div>
          </TooltipComponent>
        </TooltipComponent>
      </TooltipComponent>
    </div>
  );
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
#loader {
  color: #008cff;
  height: 40px;
  left: 45%;
  position: absolute;
  top: 45%;
  width: 30%;
}

#bubbletip {
  border-color: #d2a679;
}

#target {
  border-color: #e86238;
}

li {
  list-style: none;
}

.e-radio-wrapper {
  margin-top: 18px;
}

#target,
#bubbletip,
#tooltip {
  box-sizing: border-box;
  padding: 20px;
  width: 200px;
  text-align: center;
  top: -17px;
  margin-bottom: 40px;
}

/* csslint ignore:start */

@font-face {
  font-family: "tip";
  src: url("https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.tff") format("truetype"), url("https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.woff") format("woff"), url("https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.eot") format("eot"), url("https://ej2.syncfusion.com/products/typescript/tooltip/customization/Fonts/tip.svg?#tip") format("svg");
  font-weight: normal;
  font-style: normal;
}

/* csslint ignore:end */

/* csslint ignore:start */

#container {
  width: 100%;
}

.customTipContainer {
  width: 400px;
  position: relative;
  left: 50%;
  transform: translateX(-50%);
  top: 70px;
}

#disabledContainer {
  margin-top: 25px;
}

.pointertip.e-tooltip-wrap .e-tip-content,
.curvetips.e-tooltip-wrap .e-tip-content {
  color: white;
}

.pointertip.e-tooltip-wrap.e-popup {
  background-color: #80180d;
  border: 3px solid #ff9999;
}

.curvetips .e-arrow-tip.e-tip-top {
  margin-left: -20px;
  top: -16px;
  transform: rotate(177deg);
  left: 50px;
}

.curvetips.e-tooltip-wrap {
  padding: 17px;
  border-radius: 5px;
}

.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom:before,
.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top:before {
  font-family: "tip" !important;
  speak-as: none;
  font-size: 21px;
  font-style: normal;
  font-weight: normal;
  font-variant: normal;
  text-transform: none;
  line-height: 1;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  content: "\e700";
  color: #e86238;
}

.curvetips.e-tooltip-wrap.e-popup {
  background: #e86238;
  border: none;
}

.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom,
.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top {
  border-left: none;
  border-right: none;
  border-top: none;
}

.curvetips.e-tooltip-wrap .e-arrow-tip-inner.e-tip-bottom:before,
.curvetips.e-tooltip-wrap .e-arrow-tip-inner.e-tip-top:before {
  content: none;
}

.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom,
.curvetips.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top {
  top: -1px;
}

.curvetips.e-tooltip-wrap .e-arrow-tip.e-tip-bottom,
.curvetips.e-tooltip-wrap .e-arrow-tip.e-tip-top {
  position: absolute;
  height: 18px;
  width: 28px;
}

#positions,
#btn {
  display: inline-block;
}

#target .e-tip-content {
  padding: 0px;
}

.bubbletip.e-tooltip-wrap {
  padding: 8px;
}

.bubbletip.e-tooltip-wrap .e-tip-content {
  border-radius: 50%;
  text-align: center;
  color: white;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-bottom {
  height: 40px;
  width: 50px;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-top {
  height: 40px;
  width: 40px;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-left,
.bubbletip.e-tooltip-wrap .e-arrow-tip.e-tip-right {
  height: 12px;
  width: 20px;
}


.bubbletip.e-tooltip-wrap.e-popup {
  border: 5px solid #dfccad;
  background-color: #7b5e32;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-bottom {
  height: 10px;
  width: 10px;
  border: 1px solid #dfccad;
  background-color: #7b5e32;
  border-radius: 50px;
  margin-top: 20px;
  margin-right: 20px;
}

.e-arrow-tip.e-tip-top {
  margin-left: 60px;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-top {
  border: 1px solid #dfccad;
  border-radius: 50px;
  background-color: #7b5e32;
  width: 10px;
  height: 10px;
  margin-left: 20px;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-left {
  border-bottom: 6px solid transparent;
  border-right: 20px solid #dfccad;
  border-top: 6px solid transparent;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-outer.e-tip-right {
  border-bottom: 6px solid transparent;
  border-left: 20px solid #dfccad;
  border-top: 6px solid transparent;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-bottom {
  margin-top: -2px;
  margin-left: 8px;
  content: none;
  top: 1px !important;
  border: 2px solid #dfccad;
  width: 20px;
  height: 20px;
  border-radius: 50px;
  background-color: #7b5e32;
}

.bubbletip .e-arrow-tip.e-tip-top {
  left: 44px !important;
  top: -19px !important;
}

.bubbletip .e-arrow-tip.e-tip-bottom {
  top: 88.9% !important;
  left: 4px !important;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-top {
  top: 10px !important;
  border: 2px solid #dfccad;
  width: 20px;
  height: 20px;
  border-radius: 50px;
  background-color: #7b5e32;
}

.bubbletip.e-tooltip-wrap .e-arrow-tip-inner.e-tip-top:before {
  content: None;
}

.bubbletip.e-tooltip-wrap .e-tip-content {
  border-radius: inherit;
}

.bubbletip.e-tooltip-wrap.bubbletip {
  width: 150px !important;
  border-radius: 50%;
}

/* csslint ignore:end */
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Tooltip</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-base/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-react-popups/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-react-buttons/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-inputs/styles/material.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id='sample'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>